diff --git a/src/MQTTAsync.c b/src/MQTTAsync.c
index 8fe328f0..cbb9b085 100644
--- a/src/MQTTAsync.c
+++ b/src/MQTTAsync.c
@@ -454,7 +454,9 @@ static int MQTTAsync_processCommand(void);
 static void MQTTAsync_checkTimeouts(void);
 static thread_return_type WINAPI MQTTAsync_sendThread(void* n);
 static void MQTTAsync_emptyMessageQueue(Clients* client);
-static void MQTTAsync_removeResponsesAndCommands(MQTTAsyncs* m);
+static void MQTTAsync_freeResponses(MQTTAsyncs* m);
+static void MQTTAsync_freeCommands(MQTTAsyncs* m);
+static int MQTTAsync_unpersistCommandsAndMessages(Clients* c);
 static int MQTTAsync_completeConnection(MQTTAsyncs* m, Connack* connack);
 static thread_return_type WINAPI MQTTAsync_receiveThread(void* n);
 static void MQTTAsync_stop(void);
@@ -703,11 +705,16 @@ int MQTTAsync_createWithOptions(MQTTAsync* handle, const char* serverURI, const
 	rc = MQTTPersistence_create(&(m->c->persistence), persistence_type, persistence_context);
 	if (rc == 0)
 	{
-		rc = MQTTPersistence_initialize(m->c, m->serverURI);
+		rc = MQTTPersistence_initialize(m->c, m->serverURI); /* inflight messages restored here */
 		if (rc == 0)
 		{
-			MQTTAsync_restoreCommands(m);
-			MQTTPersistence_restoreMessageQueue(m->c);
+			if (m->createOptions && m->createOptions->struct_version >= 2 && m->createOptions->restoreMessages == 0)
+				MQTTAsync_unpersistCommandsAndMessages(m->c);
+			else
+			{
+				MQTTAsync_restoreCommands(m);
+				MQTTPersistence_restoreMessageQueue(m->c);
+			}
 		}
 	}
 #endif
@@ -1175,6 +1182,80 @@ static int MQTTAsync_restoreCommands(MQTTAsyncs* client)
 	FUNC_EXIT_RC(rc);
 	return rc;
 }
+
+
+static int MQTTAsync_unpersistCommandsAndMessages(Clients* c)
+{
+	int rc = 0;
+	char **msgkeys;
+	int nkeys;
+	int i = 0;
+	int messages_deleted = 0;
+
+	FUNC_ENTRY;
+	if (c->persistence && (rc = c->persistence->pkeys(c->phandle, &msgkeys, &nkeys)) == 0)
+	{
+		while (rc == 0 && i < nkeys)
+		{
+			if (strncmp(msgkeys[i], PERSISTENCE_COMMAND_KEY, strlen(PERSISTENCE_COMMAND_KEY)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_V5_COMMAND_KEY, strlen(PERSISTENCE_V5_COMMAND_KEY)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_QUEUE_KEY, strlen(PERSISTENCE_QUEUE_KEY)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_V5_QUEUE_KEY, strlen(PERSISTENCE_V5_QUEUE_KEY)) == 0)
+			{
+				if ((rc = c->persistence->premove(c->phandle, msgkeys[i])) == 0)
+					messages_deleted++;
+				else
+					Log(LOG_ERROR, 0, "Error %d removing queued message from persistence", rc);
+			}
+			if (msgkeys[i])
+				free(msgkeys[i]);
+			i++;
+		}
+		if (msgkeys != NULL)
+			free(msgkeys);
+	}
+	Log(TRACE_MINIMUM, -1, "%d queued messages deleted for client %s", messages_deleted, c->clientID);
+	FUNC_EXIT_RC(rc);
+	return rc;
+}
+
+
+static int MQTTAsync_unpersistInflightMessages(Clients* c)
+{
+	int rc = 0;
+	char **msgkeys;
+	int nkeys;
+	int i = 0;
+	int messages_deleted = 0;
+
+	FUNC_ENTRY;
+	if (c->persistence && (rc = c->persistence->pkeys(c->phandle, &msgkeys, &nkeys)) == 0)
+	{
+		while (rc == 0 && i < nkeys)
+		{
+			if (strncmp(msgkeys[i], PERSISTENCE_PUBLISH_SENT, strlen(PERSISTENCE_PUBLISH_SENT)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_V5_PUBLISH_SENT, strlen(PERSISTENCE_V5_PUBLISH_SENT)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_PUBREL, strlen(PERSISTENCE_PUBREL)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_V5_PUBREL, strlen(PERSISTENCE_V5_PUBREL)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_PUBLISH_RECEIVED, strlen(PERSISTENCE_PUBLISH_RECEIVED)) == 0 ||
+				strncmp(msgkeys[i], PERSISTENCE_V5_PUBLISH_RECEIVED, strlen(PERSISTENCE_V5_PUBLISH_RECEIVED)) == 0)
+			{
+				if ((rc = c->persistence->premove(c->phandle, msgkeys[i])) == 0)
+					messages_deleted++;
+				else
+					Log(LOG_ERROR, 0, "Error %d removing inflight message from persistence", rc);
+			}
+			if (msgkeys[i])
+				free(msgkeys[i]);
+			i++;
+		}
+		if (msgkeys != NULL)
+			free(msgkeys);
+	}
+	Log(TRACE_MINIMUM, -1, "%d inflight messages deleted for client %s", messages_deleted, c->clientID);
+	FUNC_EXIT_RC(rc);
+	return rc;
+}
 #endif
 
 /**
@@ -2135,11 +2216,9 @@ static void MQTTAsync_emptyMessageQueue(Clients* client)
 }
 
 
-static void MQTTAsync_removeResponsesAndCommands(MQTTAsyncs* m)
+static void MQTTAsync_freeResponses(MQTTAsyncs* m)
 {
 	int count = 0;
-	ListElement* current = NULL;
-	ListElement *next = NULL;
 
 	FUNC_ENTRY;
 	if (m->responses)
@@ -2181,9 +2260,18 @@ static void MQTTAsync_removeResponsesAndCommands(MQTTAsyncs* m)
 		ListEmpty(m->responses);
 	}
 	Log(TRACE_MINIMUM, -1, "%d responses removed for client %s", count, m->c->clientID);
+	FUNC_EXIT;
+}
 
+
+static void MQTTAsync_freeCommands(MQTTAsyncs* m)
+{
+	int count = 0;
+	ListElement* current = NULL;
+	ListElement *next = NULL;
+
+	FUNC_ENTRY;
 	/* remove commands in the command queue relating to this client */
-	count = 0;
 	current = ListNextElement(commands, &next);
 	ListNextElement(commands, &next);
 	while (current)
@@ -2242,7 +2330,8 @@ void MQTTAsync_destroy(MQTTAsync* handle)
 
 	MQTTAsync_closeSession(m->c, MQTTREASONCODE_SUCCESS, NULL);
 
-	MQTTAsync_removeResponsesAndCommands(m);
+	MQTTAsync_freeResponses(m);
+	MQTTAsync_freeCommands(m);
 	ListFree(m->responses);
 
 	if (m->c)
@@ -2925,38 +3014,57 @@ static int clientStructCompare(void* a, void* b)
 }
 
 
+/**
+ * Clean the MQTT session data.  This includes the MQTT inflight messages, because
+ * that is part of the MQTT state that will be cleared by the MQTT broker too.
+ * However, queued up messages, outgoing or incoming, need (should?) not be cleared
+ * as they are outside the scope of the MQTT session.
+ */
 static int MQTTAsync_cleanSession(Clients* client)
 {
 	int rc = 0;
-	/*ListElement* found = NULL;*/
+	ListElement* found = NULL;
 
 	FUNC_ENTRY;
 #if !defined(NO_PERSISTENCE)
-	rc = MQTTPersistence_clear(client);
+	rc = MQTTAsync_unpersistInflightMessages(client);
 #endif
 	MQTTProtocol_emptyMessageList(client->inboundMsgs);
 	MQTTProtocol_emptyMessageList(client->outboundMsgs);
-	/* We used to remove complete incoming messages, but that seems to be unnecesary as they are
-	 * no longer part of the MQTT session.
-	 */
-	/*MQTTAsync_emptyMessageQueue(client);*/
 	client->msgID = 0;
-
-	/* We used to remove commands and their responses, but that seems to be unnecessary as commands that
-	 * have never been sent are not part of the MQTT session as yet.
-	 */
-	/*if ((found = ListFindItem(handles, client, clientStructCompare)) != NULL)
+	if ((found = ListFindItem(handles, client, clientStructCompare)) != NULL)
 	{
 		MQTTAsyncs* m = (MQTTAsyncs*)(found->content);
-		MQTTAsync_removeResponsesAndCommands(m);
+		MQTTAsync_freeResponses(m);
 	}
 	else
-		Log(LOG_ERROR, -1, "cleanSession: did not find client structure in handles list");*/
+		Log(LOG_ERROR, -1, "cleanSession: did not find client structure in handles list");
 	FUNC_EXIT_RC(rc);
 	return rc;
 }
 
 
+/*
+static int MQTTAsync_freeSession(Clients* client)
+{
+	int rc = 0;
+	ListElement* found = NULL;
+
+	FUNC_ENTRY;
+	MQTTAsync_emptyMessageQueue(client);
+
+	if ((found = ListFindItem(handles, client, clientStructCompare)) != NULL)
+	{
+		MQTTAsyncs* m = (MQTTAsyncs*)(found->content);
+		MQTTAsync_freeCommands(m);
+	}
+	else
+		Log(LOG_ERROR, -1, "freeSession: did not find client structure in handles list");
+	FUNC_EXIT_RC(rc);
+	return rc;
+}*/
+
+
 static int MQTTAsync_deliverMessage(MQTTAsyncs* m, char* topicName, size_t topicLen, MQTTAsync_message* mm)
 {
 	int rc;
diff --git a/src/MQTTAsync.h b/src/MQTTAsync.h
index df03194a..0d0a2317 100644
--- a/src/MQTTAsync.h
+++ b/src/MQTTAsync.h
@@ -869,7 +869,7 @@ typedef struct
 	char struct_id[4];
 	/** The version number of this structure.  Must be 0, 1 or 2
 	 * 0 means no MQTTVersion
-	 * 1 means no allowDisconnectedSendAtAnyTime, deleteOldestMessages
+	 * 1 means no allowDisconnectedSendAtAnyTime, deleteOldestMessages, restoreMessages
 	 */
 	int struct_version;
 	/** Whether to allow messages to be sent when the client library is not connected. */
@@ -890,11 +890,15 @@ typedef struct
 	 * When the maximum number of buffered messages is reached, delete the oldest rather than the newest.
 	 */
 	int deleteOldestMessages;
+	/*
+	 * Restore messages from persistence on create - or clear it.
+	 */
+	int restoreMessages;
 } MQTTAsync_createOptions;
 
-#define MQTTAsync_createOptions_initializer  { {'M', 'Q', 'C', 'O'}, 2, 0, 100, MQTTVERSION_DEFAULT, 0, 0 }
+#define MQTTAsync_createOptions_initializer  { {'M', 'Q', 'C', 'O'}, 2, 0, 100, MQTTVERSION_DEFAULT, 0, 0, 1}
 
-#define MQTTAsync_createOptions_initializer5 { {'M', 'Q', 'C', 'O'}, 2, 0, 100, MQTTVERSION_5, 0, 0 }
+#define MQTTAsync_createOptions_initializer5 { {'M', 'Q', 'C', 'O'}, 2, 0, 100, MQTTVERSION_5, 0, 0, 1}
 
 
 LIBMQTT_API int MQTTAsync_createWithOptions(MQTTAsync* handle, const char* serverURI, const char* clientId,
diff --git a/src/MQTTPersistence.h b/src/MQTTPersistence.h
index 7cda2030..a68aab90 100644
--- a/src/MQTTPersistence.h
+++ b/src/MQTTPersistence.h
@@ -1,5 +1,5 @@
 /*******************************************************************************
- * Copyright (c) 2009, 2018 IBM Corp.
+ * Copyright (c) 2009, 2020 IBM Corp.
  *
  * All rights reserved. This program and the accompanying materials
  * are made available under the terms of the Eclipse Public License v2.0
@@ -45,9 +45,9 @@
 #define PERSISTENCE_COMMAND_KEY "c-"
 /** Stem of the key for an MQTT V5 async client command */
 #define PERSISTENCE_V5_COMMAND_KEY "c5-"
-/** Stem of the key for an async client message queue */
+/** Stem of the key for an client incoming message queue */
 #define PERSISTENCE_QUEUE_KEY "q-"
-/** Stem of the key for an MQTT V5 message queue */
+/** Stem of the key for an MQTT V5 incoming message queue */
 #define PERSISTENCE_V5_QUEUE_KEY "q5-"
 #define PERSISTENCE_MAX_KEY_LENGTH 8
 
diff --git a/test/test4.c b/test/test4.c
index 2edd00d2..08d38091 100644
--- a/test/test4.c
+++ b/test/test4.c
@@ -1608,11 +1608,6 @@ int test8(struct Options options)
  	assert("getPendingTokens rc == 0", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
 	assert("should get no tokens back", tokens == NULL, "tokens was %p", tokens);
 
-	assert("test8_publishFailures == 0", test8_publishFailures == 0,
-		   "test8_publishFailures = %d", test8_publishFailures);
-
-	MQTTAsync_destroy(&c);
-
 	assert("test8_publishFailures > 0", test8_publishFailures > 0,
 		   "test8_publishFailures = %d", test8_publishFailures);
 
@@ -1620,19 +1615,6 @@ int test8(struct Options options)
 
 	test8_subscribed = test8_publishFailures = 0;
 
-	MQTTAsync_setTraceLevel(MQTTASYNC_TRACE_ERROR);
-	rc = MQTTAsync_create(&c, options.connection, "async_test8",
-			MQTTCLIENT_PERSISTENCE_DEFAULT, NULL);
-	assert("good rc from create",  rc == MQTTASYNC_SUCCESS, "rc was %d\n", rc);
-	if (rc != MQTTASYNC_SUCCESS)
-	{
-		MQTTAsync_destroy(&c);
-		goto exit;
-	}
-
-	rc = MQTTAsync_setCallbacks(c, c, NULL, test8_messageArrived, NULL);
-	assert("Good rc from setCallbacks", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
-
 	MyLog(LOGA_DEBUG, "Connecting");
 	opts.cleansession = 0;
 	opts.onSuccess = test8_onConnect;
@@ -1691,6 +1673,46 @@ int test8(struct Options options)
 	assert("test8_publishFailures > 0", test8_publishFailures > 0,
 		   "test8_publishFailures = %d", test8_publishFailures);
 
+	/* cleanup persistence of any left over message data*/
+
+	MQTTAsync_setTraceLevel(MQTTASYNC_TRACE_ERROR);
+	rc = MQTTAsync_create(&c, options.connection, "async_test8",
+				MQTTCLIENT_PERSISTENCE_DEFAULT, NULL);
+	assert("good rc from create",  rc == MQTTASYNC_SUCCESS, "rc was %d\n", rc);
+	if (rc != MQTTASYNC_SUCCESS)
+	{
+		MQTTAsync_destroy(&c);
+		goto exit;
+	}
+
+	test8_subscribed = 0;
+	opts.cleansession = 1;
+
+	rc = MQTTAsync_connect(c, &opts);
+	assert("Good rc from connect", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
+	if (rc != MQTTASYNC_SUCCESS)
+		goto exit;
+
+	while (!test8_subscribed)
+#if defined(_WIN32)
+		Sleep(100);
+#else
+		usleep(10000L);
+#endif
+
+	test_finished = 0;
+	rc = MQTTAsync_disconnect(c, &dopts);
+	assert("Good rc from disconnect", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
+
+	while (!test_finished)
+#if defined(_WIN32)
+		Sleep(100);
+#else
+		usleep(10000L);
+#endif
+
+	MQTTAsync_destroy(&c);
+
 exit:
 	MyLog(LOGA_INFO, "TEST8: test %s. %d tests run, %d failures.",
 			(failures == 0) ? "passed" : "failed", tests, failures);
diff --git a/test/test45.c b/test/test45.c
index 21168a23..6f6803e9 100644
--- a/test/test45.c
+++ b/test/test45.c
@@ -1919,11 +1919,6 @@ int test8(struct Options options)
 
 	waitForNoPendingTokens(c);
 
-	assert("test8_publishFailures == 0", test8_publishFailures == 0,
-		   "test8_publishFailures = %d", test8_publishFailures);
-
-	MQTTAsync_destroy(&c);
-
 	assert("test8_publishFailures > 0", test8_publishFailures > 0,
 		   "test8_publishFailures = %d", test8_publishFailures);
 
@@ -1931,19 +1926,6 @@ int test8(struct Options options)
 
 	test8_subscribed = test8_publishFailures = 0;
 
-	MQTTAsync_setTraceLevel(MQTTASYNC_TRACE_ERROR);
-	rc = MQTTAsync_createWithOptions(&c, options.connection, "async_test8",
-			MQTTCLIENT_PERSISTENCE_DEFAULT, NULL, &createOpts);
-	assert("good rc from create",  rc == MQTTASYNC_SUCCESS, "rc was %d\n", rc);
-	if (rc != MQTTASYNC_SUCCESS)
-	{
-		MQTTAsync_destroy(&c);
-		goto exit;
-	}
-
-	rc = MQTTAsync_setCallbacks(c, c, NULL, test8_messageArrived, NULL);
-	assert("Good rc from setCallbacks", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
-
 	MyLog(LOGA_DEBUG, "Connecting");
 	opts.onSuccess5 = test8_onConnect;
 
@@ -2000,6 +1982,39 @@ int test8(struct Options options)
 	assert("test8_publishFailures > 0", test8_publishFailures > 0,
 		   "test8_publishFailures = %d", test8_publishFailures);
 
+	/* cleanup persistence of any left over message data*/
+
+	MQTTAsync_setTraceLevel(MQTTASYNC_TRACE_ERROR);
+	rc = MQTTAsync_createWithOptions(&c, options.connection, "async_test8",
+				MQTTCLIENT_PERSISTENCE_DEFAULT, NULL, &createOpts);
+	assert("good rc from create",  rc == MQTTASYNC_SUCCESS, "rc was %d\n", rc);
+	if (rc != MQTTASYNC_SUCCESS)
+	{
+		MQTTAsync_destroy(&c);
+		goto exit;
+	}
+
+	test8_subscribed = 0;
+	opts.connectProperties = NULL;
+	opts.cleanstart = 1;
+
+	rc = MQTTAsync_connect(c, &opts);
+	assert("Good rc from connect", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
+	if (rc != MQTTASYNC_SUCCESS)
+		goto exit;
+
+	while (!test8_subscribed)
+		MySleep(100);
+
+	test_finished = 0;
+	rc = MQTTAsync_disconnect(c, &dopts);
+	assert("Good rc from disconnect", rc == MQTTASYNC_SUCCESS, "rc was %d", rc);
+
+	while (!test_finished)
+		MySleep(100);
+
+	MQTTAsync_destroy(&c);
+
 exit:
 	MyLog(LOGA_INFO, "TEST8: test %s. %d tests run, %d failures.",
 			(failures == 0) ? "passed" : "failed", tests, failures);
